Index: Contents/Packages/bin-1.pkg/Contents/Info.plist
===================================================================
--- Contents/Packages/bin-1.pkg/Contents/Info.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/Packages/bin-1.pkg/Contents/Info.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,40 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>CFBundleIdentifier</key>
+	<string>com.sipb.gutenbach.bin.pkg</string>
+	<key>CFBundleShortVersionString</key>
+	<string>1.0</string>
+	<key>IFMajorVersion</key>
+	<integer>1</integer>
+	<key>IFMinorVersion</key>
+	<integer>0</integer>
+	<key>IFPkgFlagAllowBackRev</key>
+	<false/>
+	<key>IFPkgFlagAuthorizationAction</key>
+	<string>RootAuthorization</string>
+	<key>IFPkgFlagDefaultLocation</key>
+	<string>/usr/share/man/man1/</string>
+	<key>IFPkgFlagFollowLinks</key>
+	<true/>
+	<key>IFPkgFlagInstallFat</key>
+	<false/>
+	<key>IFPkgFlagInstalledSize</key>
+	<integer>48</integer>
+	<key>IFPkgFlagIsRequired</key>
+	<false/>
+	<key>IFPkgFlagOverwritePermissions</key>
+	<false/>
+	<key>IFPkgFlagRelocatable</key>
+	<false/>
+	<key>IFPkgFlagRestartAction</key>
+	<string>None</string>
+	<key>IFPkgFlagRootVolumeOnly</key>
+	<false/>
+	<key>IFPkgFlagUpdateInstalledLanguages</key>
+	<false/>
+	<key>IFPkgFormatVersion</key>
+	<real>0.10000000149011612</real>
+</dict>
+</plist>
Index: Contents/Packages/bin-1.pkg/Contents/PkgInfo
===================================================================
--- Contents/Packages/bin-1.pkg/Contents/PkgInfo	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/Packages/bin-1.pkg/Contents/PkgInfo	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,1 @@
+pmkrpkg1
Index: Contents/Packages/bin-1.pkg/Contents/Resources/en.lproj/Description.plist
===================================================================
--- Contents/Packages/bin-1.pkg/Contents/Resources/en.lproj/Description.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/Packages/bin-1.pkg/Contents/Resources/en.lproj/Description.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,10 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IFPkgDescriptionDescription</key>
+	<string></string>
+	<key>IFPkgDescriptionTitle</key>
+	<string>bin</string>
+</dict>
+</plist>
Index: Contents/Packages/bin-1.pkg/Contents/Resources/package_version
===================================================================
--- Contents/Packages/bin-1.pkg/Contents/Resources/package_version	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/Packages/bin-1.pkg/Contents/Resources/package_version	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,2 @@
+major: 1
+minor: 0
Index: Contents/Packages/bin.pkg/Contents/Info.plist
===================================================================
--- Contents/Packages/bin.pkg/Contents/Info.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/Packages/bin.pkg/Contents/Info.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,40 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>CFBundleIdentifier</key>
+	<string>com.sipb.gutenbach.bin-1.pkg</string>
+	<key>CFBundleShortVersionString</key>
+	<string>1.0</string>
+	<key>IFMajorVersion</key>
+	<integer>1</integer>
+	<key>IFMinorVersion</key>
+	<integer>0</integer>
+	<key>IFPkgFlagAllowBackRev</key>
+	<false/>
+	<key>IFPkgFlagAuthorizationAction</key>
+	<string>RootAuthorization</string>
+	<key>IFPkgFlagDefaultLocation</key>
+	<string>/usr/bin/</string>
+	<key>IFPkgFlagFollowLinks</key>
+	<true/>
+	<key>IFPkgFlagInstallFat</key>
+	<false/>
+	<key>IFPkgFlagInstalledSize</key>
+	<integer>32</integer>
+	<key>IFPkgFlagIsRequired</key>
+	<false/>
+	<key>IFPkgFlagOverwritePermissions</key>
+	<false/>
+	<key>IFPkgFlagRelocatable</key>
+	<false/>
+	<key>IFPkgFlagRestartAction</key>
+	<string>None</string>
+	<key>IFPkgFlagRootVolumeOnly</key>
+	<false/>
+	<key>IFPkgFlagUpdateInstalledLanguages</key>
+	<false/>
+	<key>IFPkgFormatVersion</key>
+	<real>0.10000000149011612</real>
+</dict>
+</plist>
Index: Contents/Packages/bin.pkg/Contents/PkgInfo
===================================================================
--- Contents/Packages/bin.pkg/Contents/PkgInfo	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/Packages/bin.pkg/Contents/PkgInfo	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,1 @@
+pmkrpkg1
Index: Contents/Packages/bin.pkg/Contents/Resources/en.lproj/Description.plist
===================================================================
--- Contents/Packages/bin.pkg/Contents/Resources/en.lproj/Description.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/Packages/bin.pkg/Contents/Resources/en.lproj/Description.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,10 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IFPkgDescriptionDescription</key>
+	<string></string>
+	<key>IFPkgDescriptionTitle</key>
+	<string>bin</string>
+</dict>
+</plist>
Index: Contents/Packages/bin.pkg/Contents/Resources/package_version
===================================================================
--- Contents/Packages/bin.pkg/Contents/Resources/package_version	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/Packages/bin.pkg/Contents/Resources/package_version	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,2 @@
+major: 1
+minor: 0
Index: Contents/Packages/bin.pkg/Contents/Resources/preinstall
===================================================================
--- Contents/Packages/bin.pkg/Contents/Resources/preinstall	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/Packages/bin.pkg/Contents/Resources/preinstall	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,3 @@
+#!/bin/bash
+cpan Net::CUPS
+cpan Image::ExifTool
Index: Contents/distribution.dist
===================================================================
--- Contents/distribution.dist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ Contents/distribution.dist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="utf-8"?>
+<installer-script minSpecVersion="1.000000" authoringTool="com.apple.PackageMaker" authoringToolVersion="3.0.4" authoringToolBuild="179">
+    <title>Gutenbach</title>
+    <options customize="allow" allow-external-scripts="no" rootVolumeOnly="false"/>
+    <choices-outline>
+        <line choice="choice4"/>
+        <line choice="choice9"/>
+    </choices-outline>
+    <choice id="choice4" title="bin">
+        <pkg-ref id="com.sipb.gutenbach.bin-1.pkg"/>
+    </choice>
+    <choice id="choice9" title="bin">
+        <pkg-ref id="com.sipb.gutenbach.bin.pkg"/>
+    </choice>
+    <pkg-ref id="com.sipb.gutenbach.bin-1.pkg" installKBytes="32" version="1.0" auth="Root">file:./Contents/Packages/bin.pkg</pkg-ref>
+    <pkg-ref id="com.sipb.gutenbach.bin.pkg" installKBytes="48" version="1.0" auth="Root">file:./Contents/Packages/bin-1.pkg</pkg-ref>
+</installer-script>
Index: mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/Info.plist
===================================================================
--- mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/Info.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/Info.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,40 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>CFBundleIdentifier</key>
+	<string>com.sipb.gutenbach.bin.pkg</string>
+	<key>CFBundleShortVersionString</key>
+	<string>1.0</string>
+	<key>IFMajorVersion</key>
+	<integer>1</integer>
+	<key>IFMinorVersion</key>
+	<integer>0</integer>
+	<key>IFPkgFlagAllowBackRev</key>
+	<false/>
+	<key>IFPkgFlagAuthorizationAction</key>
+	<string>RootAuthorization</string>
+	<key>IFPkgFlagDefaultLocation</key>
+	<string>/usr/share/man/man1/</string>
+	<key>IFPkgFlagFollowLinks</key>
+	<true/>
+	<key>IFPkgFlagInstallFat</key>
+	<false/>
+	<key>IFPkgFlagInstalledSize</key>
+	<integer>48</integer>
+	<key>IFPkgFlagIsRequired</key>
+	<false/>
+	<key>IFPkgFlagOverwritePermissions</key>
+	<false/>
+	<key>IFPkgFlagRelocatable</key>
+	<false/>
+	<key>IFPkgFlagRestartAction</key>
+	<string>None</string>
+	<key>IFPkgFlagRootVolumeOnly</key>
+	<false/>
+	<key>IFPkgFlagUpdateInstalledLanguages</key>
+	<false/>
+	<key>IFPkgFormatVersion</key>
+	<real>0.10000000149011612</real>
+</dict>
+</plist>
Index: mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/PkgInfo
===================================================================
--- mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/PkgInfo	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/PkgInfo	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,1 @@
+pmkrpkg1
Index: mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/Resources/en.lproj/Description.plist
===================================================================
--- mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/Resources/en.lproj/Description.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/Resources/en.lproj/Description.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,10 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IFPkgDescriptionDescription</key>
+	<string></string>
+	<key>IFPkgDescriptionTitle</key>
+	<string>bin</string>
+</dict>
+</plist>
Index: mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/Resources/package_version
===================================================================
--- mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/Resources/package_version	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/Packages/bin-1.pkg/Contents/Resources/package_version	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,2 @@
+major: 1
+minor: 0
Index: mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Info.plist
===================================================================
--- mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Info.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Info.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,40 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>CFBundleIdentifier</key>
+	<string>com.sipb.gutenbach.bin-1.pkg</string>
+	<key>CFBundleShortVersionString</key>
+	<string>1.0</string>
+	<key>IFMajorVersion</key>
+	<integer>1</integer>
+	<key>IFMinorVersion</key>
+	<integer>0</integer>
+	<key>IFPkgFlagAllowBackRev</key>
+	<false/>
+	<key>IFPkgFlagAuthorizationAction</key>
+	<string>RootAuthorization</string>
+	<key>IFPkgFlagDefaultLocation</key>
+	<string>/usr/bin/</string>
+	<key>IFPkgFlagFollowLinks</key>
+	<true/>
+	<key>IFPkgFlagInstallFat</key>
+	<false/>
+	<key>IFPkgFlagInstalledSize</key>
+	<integer>32</integer>
+	<key>IFPkgFlagIsRequired</key>
+	<false/>
+	<key>IFPkgFlagOverwritePermissions</key>
+	<false/>
+	<key>IFPkgFlagRelocatable</key>
+	<false/>
+	<key>IFPkgFlagRestartAction</key>
+	<string>None</string>
+	<key>IFPkgFlagRootVolumeOnly</key>
+	<false/>
+	<key>IFPkgFlagUpdateInstalledLanguages</key>
+	<false/>
+	<key>IFPkgFormatVersion</key>
+	<real>0.10000000149011612</real>
+</dict>
+</plist>
Index: mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/PkgInfo
===================================================================
--- mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/PkgInfo	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/PkgInfo	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,1 @@
+pmkrpkg1
Index: mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Resources/en.lproj/Description.plist
===================================================================
--- mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Resources/en.lproj/Description.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Resources/en.lproj/Description.plist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,10 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IFPkgDescriptionDescription</key>
+	<string></string>
+	<key>IFPkgDescriptionTitle</key>
+	<string>bin</string>
+</dict>
+</plist>
Index: mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Resources/package_version
===================================================================
--- mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Resources/package_version	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Resources/package_version	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,2 @@
+major: 1
+minor: 0
Index: mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Resources/preinstall
===================================================================
--- mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Resources/preinstall	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/Packages/bin.pkg/Contents/Resources/preinstall	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,3 @@
+#!/bin/bash
+cpan Net::CUPS
+cpan Image::ExifTool
Index: mac/gutenbach.mpkg/Contents/distribution.dist
===================================================================
--- mac/gutenbach.mpkg/Contents/distribution.dist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
+++ mac/gutenbach.mpkg/Contents/distribution.dist	(revision 7a98084b1dba0b3ce9b89ed3ffb80e5c1bffb7ae)
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="utf-8"?>
+<installer-script minSpecVersion="1.000000" authoringTool="com.apple.PackageMaker" authoringToolVersion="3.0.4" authoringToolBuild="179">
+    <title>Gutenbach</title>
+    <options customize="allow" allow-external-scripts="no" rootVolumeOnly="false"/>
+    <choices-outline>
+        <line choice="choice4"/>
+        <line choice="choice9"/>
+    </choices-outline>
+    <choice id="choice4" title="bin">
+        <pkg-ref id="com.sipb.gutenbach.bin-1.pkg"/>
+    </choice>
+    <choice id="choice9" title="bin">
+        <pkg-ref id="com.sipb.gutenbach.bin.pkg"/>
+    </choice>
+    <pkg-ref id="com.sipb.gutenbach.bin-1.pkg" installKBytes="32" version="1.0" auth="Root">file:./Contents/Packages/bin.pkg</pkg-ref>
+    <pkg-ref id="com.sipb.gutenbach.bin.pkg" installKBytes="48" version="1.0" auth="Root">file:./Contents/Packages/bin-1.pkg</pkg-ref>
+</installer-script>