Index: server/inst/cups-set-perms
===================================================================
--- server/inst/cups-set-perms	(revision 30beeab008c68e1e024ed39a16b17a5d50ed07a3)
+++ server/inst/cups-set-perms	(revision 25df647d1d9c9dd6582beaea835da9faced024c6)
@@ -8,30 +8,73 @@
 
     conffile="/etc/cups/cupsd.conf"
-    mv "$conffile" "$conffile.bak"
+    mv "$conffile" "$conffile.gutenbach-orig"
     touch "$conffile"
 
-    while read line; do
-	listen_localhost=$(echo "$line" | grep '^Listen localhost' || true)
-	if [ -n "$listen_localhost" ]; then
-	    echo "#GUTENBACH$line" >> "$conffile"
-       	else
-	    root_location=$(echo "$line" | grep '^<Location />$' || true)
-	    if [ -n "$root_location" ]; then
-		echo "<Location />" >> "$conffile"
-		echo "Allow from All # added by Gutenbach" >> "$conffile"
-	    else
-		echo "$line" >> "$conffile"
-	    fi
-	fi
+    cat >> "$conffile" <<EOF
+#
+# This cupsd.conf was generated by the Gutenbach music spooler
+#
 
-    done < "$conffile.bak"
-    rm "$conffile.bak"
+# Log general information in error_log - change "info" to "debug" for
+# troubleshooting...
+LogLevel warning
 
-    cat >> "$conffile" <<EOF
-# Begin configurations for gutenbach
+# Administrator user group...
+SystemGroup lpadmin
+Group audio
 
-Group audio
+Listen /var/run/cups/cups.sock
 Listen *
+
 ServerAlias *
+
+# Default authentication type, when authentication is required...
+DefaultAuthType Basic
+
+# Restrict access to the server...
+<Location />
+Allow from All
+Order deny,allow
+</Location>
+
+# Restrict access to the admin pages...
+<Location /admin>
+Encryption Required
+Order deny,allow
+</Location>
+
+# Restrict access to configuration files...
+<Location /admin/conf>
+AuthType Default
+Require user @SYSTEM
+Order deny,allow
+</Location>
+
+# Set the default printer/job policies...
+<Policy default>
+# Job-related operations must be done by the owner or an administrator...
+<Limit Send-Document Send-URI Hold-Job Release-Job Restart-Job Set-Job-Attributes Create-Job-Subscription Renew-Subscription Cancel-Subscription Get-Notifications Reprocess-Job Cancel-Current-Job Suspend-Current-Job Resume-Job CUPS-Move-Job>
+Allow from All
+Order deny,allow
+</Limit>
+
+# All administration operations require an administrator to authenticate...
+<Limit CUPS-Add-Modify-Printer CUPS-Delete-Printer CUPS-Add-Modify-Class CUPS-Delete-Class CUPS-Set-Default>
+AuthType Default
+Require user @SYSTEM
+Order deny,allow
+</Limit>
+
+# All printer operations require a printer operator to authenticate...
+<Limit Pause-Printer Resume-Printer Enable-Printer Disable-Printer Pause-Printer-After-Current-Job Hold-New-Jobs Release-Held-New-Jobs Deactivate-Printer Activate-Printer Restart-Printer Shutdown-Printer Startup-Printer Promote-Job Schedule-Job-After CUPS-Accept-Jobs CUPS-Reject-Jobs>
+AuthType Default
+Require user @SYSTEM
+Order deny,allow
+</Limit>
+
+<Limit All>
+Order deny,allow
+</Limit>
+</Policy>
 
 <Location /printers/$printername>
@@ -41,9 +84,7 @@
     </Limit>
 
-    Order Deny, Allow
+    Order deny,allow
     Allow from All
 </Location>
-
-# End configurations for gutenbach
 EOF
 
Index: rver/inst/edit-lpd.conf
===================================================================
--- server/inst/edit-lpd.conf	(revision 30beeab008c68e1e024ed39a16b17a5d50ed07a3)
+++ 	(revision )
@@ -1,34 +1,0 @@
-#!/bin/sh -e
-
-echo "Editing /etc/lprng/lpd.conf..." >&2
-# add the printcap path to lpd.conf
-if [ -e /etc/lprng/lpd.conf ]; then
-    mv /etc/lprng/lpd.conf /etc/lprng/lpd.conf.bak
-    touch /etc/lprng/lpd.conf	
-
-    while read line; do
-	printcap=$(echo "$line" | grep ^printcap_path= || true)
-	if [ -n "$printcap" ]; then
-	    lprngprintcap=$(echo "$line" | grep /etc/lprng/printcap || true)
-	    printcap=$(echo "$line" | grep /etc/printcap || true)
-	    if [ ! -n "$lprngprintcap" ] && [ ! -n "$printcap" ]; then
-		echo "#$line" >> /etc/lprng/lpd.conf
-		echo "$line" | sed 's,printcap_path=,printcap_path=/etc/lprng/printcap:\|,' >> /etc/lprng/lpd.conf
-	    else
-		echo "$line" >> /etc/lprng/lpd.conf
-	    fi
-	else
-	    echo "$line" >> /etc/lprng/lpd.conf
-	fi
-    done < /etc/lprng/lpd.conf.bak
-    rm /etc/lprng/lpd.conf.bak
-else
-    touch /etc/lprng/lpd.conf
-    echo "printcap_path=/etc/lprng/printcap" >> /etc/lprng/lpd.conf
-fi
-
-# add lpd_listen_port to lpd.conf
-lpd_listen_port=$(cat /etc/lprng/lpd.conf | grep ^lpd_listen_port=515 || true)
-if [ ! -n "$lpd_listen_port" ]; then
-    echo "lpd_listen_port=515" >> /etc/lprng/lpd.conf
-fi
Index: rver/inst/edit-lpd.perms
===================================================================
--- server/inst/edit-lpd.perms	(revision 30beeab008c68e1e024ed39a16b17a5d50ed07a3)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#!/bin/sh
-
-# make lpd less paranoid about accepting connections
-# (comment out REJECT NOT SERVER)
-# allow other users to dequeue music
-# (comment out REJECT SERVICE=M)
-# make it only accept A jobs
-# (add 
-#    ACCEPT SERVICE=R,P SERVER
-#    ACCEPT C=CA* SERVICE=R,P
-#    REJECT SERVICE=R,P)
-
-echo "Editing /etc/lprng/lpd.perms..." >&2
-if [ -e /etc/lprng/lpd.perms ]; then
-    mv /etc/lprng/lpd.perms /etc/lprng/lpd.perms.bak
-    touch /etc/lprng/lpd.perms	
-
-    while read line; do
-	reject_not_server=$(echo "$line" | grep '^REJECT NOT SERVER' || true)
-	if [ -n "$reject_not_server" ]; then
-	    echo "#$line" >> /etc/lprng/lpd.perms
-	    
-	    echo "## BEGIN gutenbach configuration" >> /etc/lprng/lpd.perms
-	    echo "ACCEPT SERVICE=R,P SERVER" >> /etc/lprng/lpd.perms
-	    echo "ACCEPT C=CA* SERVICE=R,P" >> /etc/lprng/lpd.perms
-	    echo "REJECT SERVICE=R,P" >> /etc/lprng/lpd.perms
-	    echo "## END gutenbach configuration" >> /etc/lprng/lpd.perms
-      	else
-	    reject_service=$(echo "$line" | grep '^REJECT SERVICE=M' || true)
-	    if [ -n "$reject_service" ]; then
-		echo "#line" >> /etc/lprng/lpd.perms
-	    else
-		echo "$line" >> /etc/lprng/lpd.perms
-	    fi
-	fi
-    done < /etc/lprng/lpd.perms.bak
-    rm /etc/lprng/lpd.perms.bak
-fi
Index: rver/inst/edit-printcap
===================================================================
--- server/inst/edit-printcap	(revision 30beeab008c68e1e024ed39a16b17a5d50ed07a3)
+++ 	(revision )
@@ -1,35 +1,0 @@
-#!/bin/sh -e
-
-echo "Editing /etc/printcap..." >&2
-if [ ! -e /etc/printcap ]; then
-    touch /etc/printcap
-fi
-
-if [ ! -e /etc/lprng/printcap ]; then
-    ln -s /etc/printcap /etc/lprng/printcap
-fi
-
-if [ -e /usr/lib/gutenbach/config/printername ]; then
-    printername=$(cat /usr/lib/gutenbach/config/printername)
-
-    printcap=$(cat /etc/printcap | grep ^`echo $printername` || true)
-    if [ ! -n "$printcap" ]; then
-    # add the appropriate entry into /etc/printcap, /etc/lprng/printcap
-	echo "$printername" >> /etc/printcap
-	echo "  :server" >> /etc/printcap
-	echo "  :cm=Gutenbach Music Spooler" >> /etc/printcap
-	echo "  :lp=/dev/null" >> /etc/printcap
-	echo "  :if=|/usr/lib/gutenbach/gutenbach-filter" >> /etc/printcap
-	echo "  :lf=/var/spool/lpd/$printername/log" >> /etc/printcap
-	echo "  :sd=/var/spool/lpd/$printername" >> /etc/printcap
-	echo "  :ml=0:mx=0:sh" >> /etc/printcap
-	echo "  :create_files" >> /etc/printcap
-	echo "  :auth_forward=kerberos5" >> /etc/printcap
-	echo "  :use_auth=kerberos5" >> /etc/printcap
-	echo "  :kerberos_id=daemon/"`hostname`".mit.edu@ATHENA.MIT.EDU" >> /etc/printcap
-	echo "  :kerberos_keytab=/etc/daemon.keytab" >> /etc/printcap
-    fi
-else
-    echo "Error: /usr/lib/gutenbach/config/printername does not exist!" >&2
-    exit 1
-fi
Index: rver/inst/run-checkpc
===================================================================
--- server/inst/run-checkpc	(revision 30beeab008c68e1e024ed39a16b17a5d50ed07a3)
+++ 	(revision )
@@ -1,22 +1,0 @@
-#!/bin/sh -e
-
-# make sure directories exist for checkpc
-echo "Running checkpc..." >&2
-if [ ! -d /var/spool/lpd ]; then
-    mkdir /var/spool/lpd
-    mkdir /var/spool/lpd/%P
-else
-    if [ ! -d /var/spool/lpd/%P ]; then
-	mkdir /var/spool/lpd/%P
-    fi
-fi
-chmod og=rwx /var/spool/lpd
-chmod og=rwx /var/spool/lpd/%P
-
-if [ -e /usr/lib/gutenbach/config/printername ]; then
-    printername=$(cat /usr/lib/gutenbach/config/printername)
-    /usr/sbin/checkpc -P"$printername" -f
-else
-    echo "Error: /usr/lib/gutenbach/config/printername does not exist!" >&2
-    exit 1
-fi